/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./assets/react/components/category-fields-table.js":
/*!**********************************************************!*\
  !*** ./assets/react/components/category-fields-table.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! moment */ "moment");
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(moment__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! lodash */ "lodash");
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./label-with-wc-tooltip */ "./assets/react/components/label-with-wc-tooltip.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../utils */ "./assets/react/utils.js");







const CategoryConfig = WCLT_Category;
const CategoryFieldsTable = props => {
  const {
    data,
    updateCategoryDate,
    updateCategoryFormat,
    updateCategoryText
  } = props;

  /**
   * Format the date into a human readable format.
   * 
   * @param {string} date 
   * @returns string
   */
  const getFormattedDate = date => {
    return moment__WEBPACK_IMPORTED_MODULE_2___default().unix(date);
  };
  const [format, setFormat] = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(data.format) ? data.format : 'static');
  const [leadTimeText, setLeadTimeText] = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(data.text) ? data.text : '');
  const [leadTimeDate, setLeadTimeDate] = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(data.date) ? data.date : '');
  var pickerDate = '';
  if (!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(leadTimeDate)) {
    pickerDate = (0,_utils__WEBPACK_IMPORTED_MODULE_6__.getBackwardsCompatibleDate)(getFormattedDate(leadTimeDate), CategoryConfig);
  }
  return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("tr", {
    className: "form-field wclt-not-per-stock"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", {
    scope: "row",
    valign: "top"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", null, CategoryConfig.labels.format)), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
    className: "select-auto"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.SelectControl, {
    value: format,
    options: CategoryConfig.labels.format_options,
    onChange: newFormat => {
      setFormat(newFormat);
      updateCategoryFormat(newFormat);
    }
  }))), format === 'static' && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("tr", {
    className: "form-field wclt-not-per-stock"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", {
    scope: "row",
    valign: "top"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_5__["default"], {
    tooltip: CategoryConfig.labels.text_help
  }, CategoryConfig.labels.text))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.TextControl, {
    value: leadTimeText,
    onChange: value => {
      setLeadTimeText(value);
      updateCategoryText(value);
    }
  }))), format === 'dynamic' && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("tr", {
    className: "form-field wclt-not-per-stock"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", {
    scope: "row",
    valign: "top"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_5__["default"], {
    tooltip: CategoryConfig.labels.date_help
  }, CategoryConfig.labels.date))), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", {
    className: "inside"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.DatePicker, {
    currentDate: pickerDate,
    onChange: newDate => {
      setLeadTimeDate(moment__WEBPACK_IMPORTED_MODULE_2___default()(newDate).format('X'));
      updateCategoryDate(moment__WEBPACK_IMPORTED_MODULE_2___default()(newDate).format('X'));
    },
    onMonthPreviewed: v => console.log(v)
  }))));
};
/* harmony default export */ __webpack_exports__["default"] = (CategoryFieldsTable);

/***/ }),

/***/ "./assets/react/components/category-fields.js":
/*!****************************************************!*\
  !*** ./assets/react/components/category-fields.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! moment */ "moment");
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(moment__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! lodash */ "lodash");
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./label-with-wc-tooltip */ "./assets/react/components/label-with-wc-tooltip.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../utils */ "./assets/react/utils.js");








const CategoryConfig = WCLT_Category;
const CategoryFields = props => {
  const {
    is_edit_page,
    updateCategoryDate,
    updateCategoryFormat,
    updateCategoryText
  } = props;

  /**
   * Format the date into a human readable format.
   * 
   * @param {string} date 
   * @returns string
   */
  const getFormattedDate = date => {
    return moment__WEBPACK_IMPORTED_MODULE_2___default().unix(date);
  };
  const [format, setFormat] = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)('static');
  const [leadTimeText, setLeadTimeText] = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)('');
  const [leadTimeDate, setLeadTimeDate] = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)('');
  var pickerDate = '';
  if (!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(leadTimeDate)) {
    pickerDate = (0,_utils__WEBPACK_IMPORTED_MODULE_6__.getBackwardsCompatibleDate)(getFormattedDate(leadTimeDate), CategoryConfig);
  }
  return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: "wclt-not-per-stock"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.SelectControl, {
    label: CategoryConfig.labels.format,
    value: format,
    options: CategoryConfig.labels.format_options,
    onChange: newFormat => {
      setFormat(newFormat);
      updateCategoryFormat(newFormat);
    }
  }), format === 'static' && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.TextControl, {
    label: (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_5__["default"], {
      tooltip: CategoryConfig.labels.text_help
    }, CategoryConfig.labels.text),
    value: leadTimeText,
    onChange: value => {
      setLeadTimeText(value);
      updateCategoryText(value);
    }
  }), format === 'dynamic' && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
    className: "inside"
  }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_5__["default"], {
    tooltip: CategoryConfig.labels.date_help
  }, CategoryConfig.labels.date), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.DatePicker, {
    currentDate: pickerDate,
    onChange: newDate => {
      setLeadTimeDate(moment__WEBPACK_IMPORTED_MODULE_2___default()(newDate).format('X'));
      updateCategoryDate(moment__WEBPACK_IMPORTED_MODULE_2___default()(newDate).format('X'));
    },
    onMonthPreviewed: v => console.log(v)
  })));
};
/* harmony default export */ __webpack_exports__["default"] = (CategoryFields);

/***/ }),

/***/ "./assets/react/components/category-stock-statuses-list.js":
/*!*****************************************************************!*\
  !*** ./assets/react/components/category-stock-statuses-list.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! moment */ "moment");
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(moment__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! lodash */ "lodash");
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./label-with-wc-tooltip */ "./assets/react/components/label-with-wc-tooltip.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../utils */ "./assets/react/utils.js");








const CategoryConfig = WCLT_Category;
const CategoryStockStatusesList = props => {
  const {
    statuses,
    updateData,
    data
  } = props;

  /**
   * Format the date into a human readable format.
   * 
   * @param {string} date 
   * @returns string
   */
  const getFormattedDate = date => {
    return moment__WEBPACK_IMPORTED_MODULE_2___default().unix(date);
  };
  return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Panel, null, (0,lodash__WEBPACK_IMPORTED_MODULE_3__.map)(statuses, (status_label, status_id) => {
    const [format, setFormat] = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(data[status_id].format) ? data[status_id].format : 'static');
    const [leadTimeText, setLeadTimeText] = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(data[status_id].text) ? data[status_id].text : '');
    const [leadTimeDate, setLeadTimeDate] = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(data[status_id].date) ? data[status_id].date : '');
    var pickerDate = null;
    if (!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(leadTimeDate)) {
      pickerDate = (0,_utils__WEBPACK_IMPORTED_MODULE_6__.getBackwardsCompatibleDate)(getFormattedDate(leadTimeDate), CategoryConfig);
    }
    return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.PanelBody, {
      key: status_id,
      title: status_label,
      initialOpen: false
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.SelectControl, {
      label: CategoryConfig.labels.format,
      value: format,
      options: CategoryConfig.labels.format_options,
      onChange: newFormat => {
        setFormat(newFormat);
        updateData(status_id, 'format', newFormat);
      }
    })), format === 'static' && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.PanelRow, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.TextControl, {
      label: (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_5__["default"], {
        tooltip: CategoryConfig.labels.text_help
      }, CategoryConfig.labels.text),
      value: leadTimeText,
      onChange: value => {
        setLeadTimeText(value);
        updateData(status_id, 'text', value);
      }
    })), format === 'dynamic' && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.PanelRow, {
      className: "alt-no-flex-panel"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_5__["default"], {
      tooltip: CategoryConfig.labels.date_help
    }, CategoryConfig.labels.date), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.DatePicker, {
      currentDate: pickerDate,
      onChange: newDate => {
        setLeadTimeDate(moment__WEBPACK_IMPORTED_MODULE_2___default()(newDate).format('X'));
        updateData(status_id, 'date', moment__WEBPACK_IMPORTED_MODULE_2___default()(newDate).format('X'));
      },
      onMonthPreviewed: v => console.log(v)
    })));
  }));
};
/* harmony default export */ __webpack_exports__["default"] = (CategoryStockStatusesList);

/***/ }),

/***/ "./assets/react/components/label-with-wc-tooltip.js":
/*!**********************************************************!*\
  !*** ./assets/react/components/label-with-wc-tooltip.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! lodash */ "lodash");
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);



const LabelWithWCTooltip = props => {
  const {
    tooltip
  } = props;
  (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
    jQuery('.woocommerce-help-tip').tipTip({
      'attribute': 'data-tip',
      'fadeIn': 50,
      'fadeOut': 50,
      'delay': 200,
      'keepAlive': true,
      'defaultPosition': "bottom"
    });
  });
  return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("span", {
    className: "label-with-tooltip"
  }, props.children, !(0,lodash__WEBPACK_IMPORTED_MODULE_1__.isEmpty)(tooltip) && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("span", {
    className: "woocommerce-help-tip",
    "data-tip": tooltip
  }));
};
/* harmony default export */ __webpack_exports__["default"] = (LabelWithWCTooltip);

/***/ }),

/***/ "./assets/react/containers/category.js":
/*!*********************************************!*\
  !*** ./assets/react/containers/category.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _components_category_stock_statuses_list__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/category-stock-statuses-list */ "./assets/react/components/category-stock-statuses-list.js");
/* harmony import */ var _components_category_fields__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../components/category-fields */ "./assets/react/components/category-fields.js");
/* harmony import */ var _components_category_fields_table__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../components/category-fields-table */ "./assets/react/components/category-fields-table.js");

/**
 * External dependencies
 */




const CategoryConfig = WCLT_Category;
const CategoryDataInputHolder = jQuery('[name=wclt_category_react]');
const CategoryFormatInputHolder = jQuery('[name=wclt_lead_time_format]');
const CategoryTextInputHolder = jQuery('[name=wclt_lead_time]');
const CategoryDateInputHolder = jQuery('[name=wclt_lead_time_date]');
class Category extends _wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Component {
  constructor(props) {
    super(props);
    this.updateData = this.updateData.bind(this);
    this.updateCategoryFormat = this.updateCategoryFormat.bind(this);
    this.updateCategoryText = this.updateCategoryText.bind(this);
    this.updateCategoryDate = this.updateCategoryDate.bind(this);
    this.state = {
      data: CategoryConfig.data,
      // holds the per stock status data
      per_stock_enabled: CategoryConfig.per_stock_enabled,
      // CategoryConfig.per_stock_enabled
      is_edit_page: jQuery('form#edittag').length > 0,
      category_format: jQuery('form#edittag').length > 0 ? CategoryConfig.singular_data.format : 'static',
      // holds the data for categories when the per stock setting is disabed 
      category_text: jQuery('form#edittag').length > 0 ? CategoryConfig.singular_data.text : '',
      // holds the data for categories when the per stock setting is disabed
      category_date: jQuery('form#edittag').length > 0 ? CategoryConfig.singular_data.date : '' // holds the data for categories when the per stock setting is disabed
    };
  }

  /**
   * On page load: 
   * - immediately print the json data if on the edit page
   */
  componentDidMount() {
    if (this.state.is_edit_page === true) {
      CategoryDataInputHolder.val(JSON.stringify(this.state.data));
      CategoryFormatInputHolder.val(this.state.category_format);
      CategoryTextInputHolder.val(this.state.category_text);
      CategoryDateInputHolder.val(this.state.category_date);
    }
  }

  /**
   * On update:
   * - update the json data within the hidden input holder.
   */
  componentDidUpdate() {
    CategoryDataInputHolder.val(JSON.stringify(this.state.data));
    CategoryFormatInputHolder.val(this.state.category_format);
    CategoryTextInputHolder.val(this.state.category_text);
    CategoryDateInputHolder.val(this.state.category_date);
  }

  /**
   * Update individual stock status settings data.
   * 
   * @param {string} status_id 
   * @param {string} property 
   * @param {mixed} value 
   */
  updateData(status_id, property, value) {
    this.setState(prevState => ({
      data: {
        ...prevState.data,
        [status_id]: {
          ...prevState.data[status_id],
          [property]: value
        }
      }
    }));
  }

  /**
   * Update the format when not using the per stock option.
   * @param {string} value 
   */
  updateCategoryFormat(value) {
    this.setState({
      category_format: value
    });
  }

  /**
   * Update the lead text when nto using the per stock option.
   * @param {string} value 
   */
  updateCategoryText(value) {
    this.setState({
      category_text: value
    });
  }

  /**
   * Update the date when not using the per stock option.
   * @param {string} value 
   */
  updateCategoryDate(value) {
    this.setState({
      category_date: value
    });
  }
  render() {
    const {
      data,
      per_stock_enabled,
      is_edit_page,
      category_format,
      category_date,
      category_text
    } = this.state;
    if (is_edit_page) {
      return per_stock_enabled ? (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("tr", {
        className: "form-field lead-time-format-wrap"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("th", {
        scope: "row",
        valign: "top"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", null, WCLT_Category.labels.title)), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("td", null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
        id: "wclt-category-editor"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_category_stock_statuses_list__WEBPACK_IMPORTED_MODULE_1__["default"], {
        statuses: WCLT_Category.statuses,
        updateData: this.updateData,
        data: data
      })))) : (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_category_fields_table__WEBPACK_IMPORTED_MODULE_3__["default"], {
        updateCategoryDate: this.updateCategoryDate,
        updateCategoryFormat: this.updateCategoryFormat,
        updateCategoryText: this.updateCategoryText,
        data: {
          'format': category_format,
          'date': category_date,
          'text': category_text
        }
      });
    } else {
      return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
        id: "wclt-category-editor"
      }, per_stock_enabled ? (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("h2", null, WCLT_Category.labels.title), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_category_stock_statuses_list__WEBPACK_IMPORTED_MODULE_1__["default"], {
        statuses: WCLT_Category.statuses,
        updateData: this.updateData,
        data: data
      })) : (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_category_fields__WEBPACK_IMPORTED_MODULE_2__["default"], {
        is_edit_page: is_edit_page,
        updateCategoryDate: this.updateCategoryDate,
        updateCategoryFormat: this.updateCategoryFormat,
        updateCategoryText: this.updateCategoryText
      }));
    }
  }
}
/* harmony default export */ __webpack_exports__["default"] = (Category);

/***/ }),

/***/ "./assets/react/utils.js":
/*!*******************************!*\
  !*** ./assets/react/utils.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getBackwardsCompatibleDate": function() { return /* binding */ getBackwardsCompatibleDate; }
/* harmony export */ });
const getBackwardsCompatibleDate = (date, config) => {
  if (!config.needs_compatibility_check) {
    return date.toDate();
  }
  return date;
};

/***/ }),

/***/ "./assets/react/category.scss":
/*!************************************!*\
  !*** ./assets/react/category.scss ***!
  \************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
// extracted by mini-css-extract-plugin


/***/ }),

/***/ "react":
/*!************************!*\
  !*** external "React" ***!
  \************************/
/***/ (function(module) {

module.exports = window["React"];

/***/ }),

/***/ "lodash":
/*!*************************!*\
  !*** external "lodash" ***!
  \*************************/
/***/ (function(module) {

module.exports = window["lodash"];

/***/ }),

/***/ "moment":
/*!*************************!*\
  !*** external "moment" ***!
  \*************************/
/***/ (function(module) {

module.exports = window["moment"];

/***/ }),

/***/ "@wordpress/components":
/*!************************************!*\
  !*** external ["wp","components"] ***!
  \************************************/
/***/ (function(module) {

module.exports = window["wp"]["components"];

/***/ }),

/***/ "@wordpress/element":
/*!*********************************!*\
  !*** external ["wp","element"] ***!
  \*********************************/
/***/ (function(module) {

module.exports = window["wp"]["element"];

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	!function() {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = function(module) {
/******/ 			var getter = module && module.__esModule ?
/******/ 				function() { return module['default']; } :
/******/ 				function() { return module; };
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
!function() {
/*!**********************************!*\
  !*** ./assets/react/category.js ***!
  \**********************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _containers_category__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./containers/category */ "./assets/react/containers/category.js");
/* harmony import */ var _category_scss__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./category.scss */ "./assets/react/category.scss");



const appRoot = document.getElementById('wclt-category-root');

(0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.render)((0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_containers_category__WEBPACK_IMPORTED_MODULE_1__["default"], null), appRoot);
}();
/******/ })()
;
//# sourceMappingURL=wc-lead-time-category.js.map