/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./assets/react/components/label-with-wc-tooltip.js":
/*!**********************************************************!*\
  !*** ./assets/react/components/label-with-wc-tooltip.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! lodash */ "lodash");
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);



const LabelWithWCTooltip = props => {
  const {
    tooltip
  } = props;
  (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
    jQuery('.woocommerce-help-tip').tipTip({
      'attribute': 'data-tip',
      'fadeIn': 50,
      'fadeOut': 50,
      'delay': 200,
      'keepAlive': true,
      'defaultPosition': "bottom"
    });
  });
  return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("span", {
    className: "label-with-tooltip"
  }, props.children, !(0,lodash__WEBPACK_IMPORTED_MODULE_1__.isEmpty)(tooltip) && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("span", {
    className: "woocommerce-help-tip",
    "data-tip": tooltip
  }));
};
/* harmony default export */ __webpack_exports__["default"] = (LabelWithWCTooltip);

/***/ }),

/***/ "./assets/react/containers/product-per-stock.js":
/*!******************************************************!*\
  !*** ./assets/react/containers/product-per-stock.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! lodash */ "lodash");
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../components/label-with-wc-tooltip */ "./assets/react/components/label-with-wc-tooltip.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../utils */ "./assets/react/utils.js");

/**
 * External dependencies
 */





const hiddenInputDataHolder = jQuery('[name=wclt-product-perstock-data]');
const statuses = WCLT_Product.statuses;
const labels = WCLT_Product.labels;
class ProductPerStock extends _wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Component {
  constructor(props) {
    super(props);
    this.state = {
      data: WCLT_Product.data
    };
  }

  /**
   * Pre-load the state into the hidden input on page load.
   */
  componentDidMount() {
    hiddenInputDataHolder.val(JSON.stringify(this.state.data));
  }

  /**
   * Each time the state is updated, save the data into the hidden input.
   */
  componentDidUpdate() {
    hiddenInputDataHolder.val(JSON.stringify(this.state.data));
  }

  /**
   * Format the date into a human readable format.
   * 
   * @param {string} date 
   * @returns string
   */
  getFormattedDate = date => {
    return moment.unix(date);
  };

  /**
   * Update individual stock status settings data.
   * 
   * @param {string} status_id 
   * @param {string} property 
   * @param {mixed} value 
   */
  updateData(status_id, property, value) {
    this.setState(prevState => ({
      data: {
        ...prevState.data,
        [status_id]: {
          ...prevState.data[status_id],
          [property]: value
        }
      }
    }));
  }
  render() {
    const {
      data
    } = this.state;
    return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, (0,lodash__WEBPACK_IMPORTED_MODULE_2__.map)(statuses, (status_label, status_id) => {
      const format = (0,lodash__WEBPACK_IMPORTED_MODULE_2__.has)(data, status_id + '.format') && !(0,lodash__WEBPACK_IMPORTED_MODULE_2__.isEmpty)(data[status_id].format) ? data[status_id].format : 'static';
      const text = (0,lodash__WEBPACK_IMPORTED_MODULE_2__.has)(data, status_id + '.text') ? data[status_id].text : '';
      const date = (0,lodash__WEBPACK_IMPORTED_MODULE_2__.has)(data, status_id + '.date') ? data[status_id].date : '';
      var pickerDate = null;
      if (!(0,lodash__WEBPACK_IMPORTED_MODULE_2__.isEmpty)(date)) {
        pickerDate = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.getBackwardsCompatibleDate)(this.getFormattedDate(date), WCLT_Product);
      }
      return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.PanelBody, {
        key: status_id,
        title: labels.block_prefix + ' - ' + status_label,
        initialOpen: false
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.PanelRow, {
        className: "alt-no-flex-panel no-label-margin"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
        className: "wclt-dynamic"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
        className: "fields-stock"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
        className: "form-field"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", {
        htmlFor: ""
      }, labels.format), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.SelectControl, {
        value: format,
        options: labels.format_options,
        onChange: newFormat => {
          this.updateData(status_id, 'format', newFormat);
        }
      })), format === 'static' && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
        className: "form-field"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", {
        htmlFor: ""
      }, labels.text), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.TextControl, {
        value: text,
        onChange: value => this.updateData(status_id, 'text', value)
      }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_3__["default"], {
        tooltip: labels.text_help
      })), format === 'dynamic' && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
        className: "form-field date-field"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", {
        htmlFor: ""
      }, labels.date), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.DatePicker, {
        currentDate: pickerDate,
        onChange: newDate => {
          this.updateData(status_id, 'date', moment(newDate).format('X'));
        },
        onMonthPreviewed: v => console.log(v)
      }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_3__["default"], {
        tooltip: labels.date_help
      }))))));
    }));
  }
}
/* harmony default export */ __webpack_exports__["default"] = (ProductPerStock);

/***/ }),

/***/ "./assets/react/containers/product-variable-per-stock.js":
/*!***************************************************************!*\
  !*** ./assets/react/containers/product-variable-per-stock.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! lodash */ "lodash");
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../components/label-with-wc-tooltip */ "./assets/react/components/label-with-wc-tooltip.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../utils */ "./assets/react/utils.js");

/**
 * External dependencies
 */



const statuses = WCLT_Product.statuses;
const labels = WCLT_Product.labels;


class ProductVariablePerStock extends _wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Component {
  constructor(props) {
    super(props);
    this.state = {
      data: null
    };
  }

  /**
   * When the metabox heading title "h3" is clicked,
   * preload the data accordingly.
   */
  componentDidMount() {
    const {
      element
    } = this.props;
    const loopID = jQuery(element).data('loop-id');
    const metaboxHeading = jQuery(element).parent().parent().parent().parent().parent().find('h3');
    metaboxHeading.on("click", () => {
      const hiddenInput = jQuery('#wclt_variation_react_data_' + loopID);
      const initialValue = JSON.parse(hiddenInput.val());
      if ((0,lodash__WEBPACK_IMPORTED_MODULE_2__.has)(initialValue, 'data')) {
        this.setState({
          data: initialValue.data
        });
      }
    });
  }

  /**
   * Simulate the need to update variations.
   * 
   * When the data is changed into the react state, the timestamp is stored into an hidden input field,
   * however WC does not recognise that the hidden input has been changed,
   * therefore we fake trigger a change to the dropdown to let WC know
   * that variations have been changed and an update into the database is required.
   * 
   * @param {object} prevProps 
   * @param {object} prevState 
   */
  componentDidUpdate(prevProps, prevState) {
    const {
      element
    } = this.props;
    const loopID = jQuery(element).data('loop-id');
    const stockStatusField = jQuery('#variable_stock_status' + loopID);
    const hiddenInput = jQuery('#wclt_variation_react_data_' + loopID);
    if (prevState.data !== this.state.data) {
      stockStatusField.trigger('change');
      hiddenInput.val(JSON.stringify(this.state.data));
    }
  }

  /**
   * Format the date into a human readable format.
   * 
   * @param {string} date 
   * @returns string
   */
  getFormattedDate = date => {
    return moment.unix(date);
  };

  /**
   * Update individual stock status settings data.
   * 
   * @param {string} status_id 
   * @param {string} property 
   * @param {mixed} value 
   */
  updateData(status_id, property, value) {
    this.setState(prevState => ({
      data: {
        ...prevState.data,
        [status_id]: {
          ...prevState.data[status_id],
          [property]: value
        }
      }
    }));
  }
  render() {
    const {
      data
    } = this.state;
    return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.Panel, null, (0,lodash__WEBPACK_IMPORTED_MODULE_2__.map)(statuses, (status_label, status_id) => {
      const format = (0,lodash__WEBPACK_IMPORTED_MODULE_2__.has)(data, status_id + '.format') && !(0,lodash__WEBPACK_IMPORTED_MODULE_2__.isEmpty)(data[status_id].format) ? data[status_id].format : 'static';
      const text = (0,lodash__WEBPACK_IMPORTED_MODULE_2__.has)(data, status_id + '.text') ? data[status_id].text : '';
      const date = (0,lodash__WEBPACK_IMPORTED_MODULE_2__.has)(data, status_id + '.date') ? data[status_id].date : '';
      var pickerDate = null;
      if (!(0,lodash__WEBPACK_IMPORTED_MODULE_2__.isEmpty)(date)) {
        pickerDate = (0,_utils__WEBPACK_IMPORTED_MODULE_4__.getBackwardsCompatibleDate)(this.getFormattedDate(date), WCLT_Product);
      }
      return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.PanelBody, {
        key: status_id,
        title: labels.block_prefix + ' - ' + status_label,
        initialOpen: false
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.PanelRow, {
        className: "alt-no-flex-panel no-label-margin wclt-variation-wrapper"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
        className: "wclt-form-field"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_3__["default"], null, labels.format), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.SelectControl, {
        value: format,
        options: labels.format_options,
        onChange: newFormat => {
          this.updateData(status_id, 'format', newFormat);
        }
      })), format === 'static' && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
        className: "wclt-form-field"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_3__["default"], {
        tooltip: labels.text_help
      }, labels.text), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.TextControl, {
        value: text,
        onChange: value => this.updateData(status_id, 'text', value)
      })), format === 'dynamic' && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
        className: "wclt-form-field date-field"
      }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_3__["default"], {
        tooltip: labels.date_help
      }, labels.date), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.DatePicker, {
        currentDate: pickerDate,
        onChange: newDate => {
          this.updateData(status_id, 'date', moment(newDate).format('X'));
        },
        onMonthPreviewed: v => console.log(v)
      }))));
    }));
  }
}
/* harmony default export */ __webpack_exports__["default"] = (ProductVariablePerStock);

/***/ }),

/***/ "./assets/react/containers/product-variable.js":
/*!*****************************************************!*\
  !*** ./assets/react/containers/product-variable.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! moment */ "moment");
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(moment__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! lodash */ "lodash");
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../components/label-with-wc-tooltip */ "./assets/react/components/label-with-wc-tooltip.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../utils */ "./assets/react/utils.js");

/**
 * External dependencies
 */






class ProductVariable extends _wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Component {
  constructor(props) {
    super(props);
    this.state = {
      is_open: null,
      date: ''
    };
  }

  /**
   * When the metabox heading title "h3" is clicked,
   * determine if the component should be displayed.
   * 
   * We need to do this because unfortunately the datepicker layout is broken
   * when the element is not visible/loaded into the dom.
   * 
   * So we force the refresh of the component when clicking the heading.
   */
  componentDidMount() {
    const {
      element
    } = this.props;
    const instance = this;
    const loopID = jQuery(element).data('loop-id');
    const metaboxHeading = jQuery(element).parent().parent().parent().parent().parent().find('h3');
    const wcltFieldsWrapper = jQuery(element).parent();
    const formatField = wcltFieldsWrapper.find('select');
    const leadTimeTextField = wcltFieldsWrapper.find('input[type=text]').get(0);
    const hiddenDateTimeStamp = wcltFieldsWrapper.find('input[type=hidden]').get(0);
    metaboxHeading.on("click", () => {
      const initialFormatValue = formatField.find('option:selected').val() || 'static';
      this.setState({
        date: jQuery(hiddenDateTimeStamp).val()
      });
      if (initialFormatValue === 'dynamic') {
        this.setState({
          is_open: true
        });
        jQuery(leadTimeTextField).parent().hide();
      } else {
        this.setState({
          is_open: false
        });
        jQuery(leadTimeTextField).parent().show();
      }
    });
    formatField.on("change", function () {
      if (this.value === 'static') {
        instance.setState({
          is_open: false
        });
        jQuery(leadTimeTextField).parent().show();
      } else {
        instance.setState({
          is_open: true
        });
        jQuery(leadTimeTextField).parent().hide();
      }
    });
  }

  /**
   * Simulate the need to update variations.
   * 
   * When the date is changed into the react state, the timestamp is stored into an hidden input field,
   * however WC does not recognise that the hidden input has been changed,
   * therefore we fake trigger a change to the dropdown to let WC know
   * that variations have been changed and an update into the database is required.
   * 
   * @param {object} prevProps 
   * @param {object} prevState 
   */
  componentDidUpdate(prevProps, prevState) {
    const {
      element
    } = this.props;
    const wcltFieldsWrapper = jQuery(element).parent();
    const formatField = wcltFieldsWrapper.find('select');
    if (prevState.is_open !== this.state.is_open) {
      formatField.trigger('change');
    }
    if (prevState.date !== this.state.date) {
      formatField.trigger('change');
    }
  }

  /**
   * Format the date into a human readable format.
   * 
   * @param {string} date 
   * @returns string
   */
  getFormattedDate = date => {
    return moment__WEBPACK_IMPORTED_MODULE_2___default().unix(date);
  };
  render() {
    const {
      element
    } = this.props;
    const {
      is_open,
      date
    } = this.state;
    var pickerDate = '';
    if (!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(date)) {
      pickerDate = (0,_utils__WEBPACK_IMPORTED_MODULE_5__.getBackwardsCompatibleDate)(this.getFormattedDate(date), WCLT_Product);
    }
    const wcltFieldsWrapper = jQuery(element).parent();
    const hiddenDateTimeStamp = wcltFieldsWrapper.find('input[type=hidden]').get(0);
    return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, is_open && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "form-field wclt-variation-wrapper"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", null, WCLT_Product.labels.date), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_4__["default"], {
      tooltip: WCLT_Product.labels.date_help
    }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "wclt-picker-wrapper"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.DatePicker, {
      currentDate: pickerDate,
      onChange: newDate => {
        this.setState({
          date: moment__WEBPACK_IMPORTED_MODULE_2___default()(newDate).format('X')
        });
        jQuery(hiddenDateTimeStamp).val(moment__WEBPACK_IMPORTED_MODULE_2___default()(newDate).format('X'));
      },
      onMonthPreviewed: v => console.log(v)
    }))));
  }
}
/* harmony default export */ __webpack_exports__["default"] = (ProductVariable);

/***/ }),

/***/ "./assets/react/containers/product.js":
/*!********************************************!*\
  !*** ./assets/react/containers/product.js ***!
  \********************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @wordpress/components */ "@wordpress/components");
/* harmony import */ var _wordpress_components__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! moment */ "moment");
/* harmony import */ var moment__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(moment__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! lodash */ "lodash");
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../components/label-with-wc-tooltip */ "./assets/react/components/label-with-wc-tooltip.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../utils */ "./assets/react/utils.js");

/**
 * External dependencies
 */




const hiddenDateElement = jQuery('#_wclt_lead_time_date');
const initialDateTimeStamp = hiddenDateElement.val();
const leadTimeTextField = jQuery('#_wclt_lead_time');


class Product extends _wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Component {
  constructor(props) {
    super(props);
    this.state = {
      is_open: null,
      date: initialDateTimeStamp
    };
  }

  /**
   * Dirty way of rendering the calendar.
   * 
   * Because we're using the DatePicker component, the calendar does not display
   * properly because the inventory tab is not initially visible, therefore
   * the calendar's styling is broken because it's not in the DOM.
   */
  componentDidMount() {
    const instance = this;
    jQuery('.inventory_tab a').on("click", function () {
      const formatElement = jQuery('#_wclt_lead_time_format');
      const initialFormatValue = jQuery('#_wclt_lead_time_format option:selected').val();
      if (initialFormatValue === 'dynamic') {
        instance.setState({
          is_open: true
        });
        leadTimeTextField.parent().hide();
      } else {
        instance.setState({
          is_open: false
        });
        leadTimeTextField.parent().show();
      }
      formatElement.on("change", function () {
        if (this.value === 'static') {
          instance.setState({
            is_open: false
          });
          leadTimeTextField.parent().show();
        } else {
          instance.setState({
            is_open: true
          });
          leadTimeTextField.parent().hide();
        }
      });
    });
  }

  /**
   * Format the date into a human readable format.
   * 
   * @param {string} date 
   * @returns string
   */
  getFormattedDate = date => {
    return moment__WEBPACK_IMPORTED_MODULE_2___default().unix(date);
  };
  render() {
    const {
      is_open,
      date
    } = this.state;
    var pickerDate = '';
    if (!(0,lodash__WEBPACK_IMPORTED_MODULE_3__.isEmpty)(date)) {
      pickerDate = (0,_utils__WEBPACK_IMPORTED_MODULE_5__.getBackwardsCompatibleDate)(this.getFormattedDate(date), WCLT_Product);
    }
    return (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, is_open && (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "form-field",
      style: {
        padding: '5px 20px 5px 162px'
      }
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("label", {
      htmlFor: "_wclt_lead_time_date"
    }, WCLT_Product.labels.date), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)("div", {
      className: "wclt-picker-wrapper"
    }, (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_wordpress_components__WEBPACK_IMPORTED_MODULE_1__.DatePicker, {
      currentDate: pickerDate,
      onChange: newDate => {
        this.setState({
          date: moment__WEBPACK_IMPORTED_MODULE_2___default()(newDate).format('X')
        });
        hiddenDateElement.val(moment__WEBPACK_IMPORTED_MODULE_2___default()(newDate).format('X'));
      },
      onMonthPreviewed: v => console.log(v)
    }), (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_components_label_with_wc_tooltip__WEBPACK_IMPORTED_MODULE_4__["default"], {
      tooltip: WCLT_Product.labels.date_help
    }))));
  }
}
/* harmony default export */ __webpack_exports__["default"] = (Product);

/***/ }),

/***/ "./assets/react/utils.js":
/*!*******************************!*\
  !*** ./assets/react/utils.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getBackwardsCompatibleDate": function() { return /* binding */ getBackwardsCompatibleDate; }
/* harmony export */ });
const getBackwardsCompatibleDate = (date, config) => {
  if (!config.needs_compatibility_check) {
    return date.toDate();
  }
  return date;
};

/***/ }),

/***/ "./assets/react/product.scss":
/*!***********************************!*\
  !*** ./assets/react/product.scss ***!
  \***********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
// extracted by mini-css-extract-plugin


/***/ }),

/***/ "react":
/*!************************!*\
  !*** external "React" ***!
  \************************/
/***/ (function(module) {

module.exports = window["React"];

/***/ }),

/***/ "lodash":
/*!*************************!*\
  !*** external "lodash" ***!
  \*************************/
/***/ (function(module) {

module.exports = window["lodash"];

/***/ }),

/***/ "moment":
/*!*************************!*\
  !*** external "moment" ***!
  \*************************/
/***/ (function(module) {

module.exports = window["moment"];

/***/ }),

/***/ "@wordpress/components":
/*!************************************!*\
  !*** external ["wp","components"] ***!
  \************************************/
/***/ (function(module) {

module.exports = window["wp"]["components"];

/***/ }),

/***/ "@wordpress/element":
/*!*********************************!*\
  !*** external ["wp","element"] ***!
  \*********************************/
/***/ (function(module) {

module.exports = window["wp"]["element"];

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	!function() {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = function(module) {
/******/ 			var getter = module && module.__esModule ?
/******/ 				function() { return module['default']; } :
/******/ 				function() { return module; };
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
!function() {
/*!*********************************!*\
  !*** ./assets/react/product.js ***!
  \*********************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @wordpress/element */ "@wordpress/element");
/* harmony import */ var _wordpress_element__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_wordpress_element__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _containers_product__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./containers/product */ "./assets/react/containers/product.js");
/* harmony import */ var _containers_product_per_stock__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./containers/product-per-stock */ "./assets/react/containers/product-per-stock.js");
/* harmony import */ var _containers_product_variable__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./containers/product-variable */ "./assets/react/containers/product-variable.js");
/* harmony import */ var _containers_product_variable_per_stock__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./containers/product-variable-per-stock */ "./assets/react/containers/product-variable-per-stock.js");
/* harmony import */ var _product_scss__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./product.scss */ "./assets/react/product.scss");


const appRoot = document.getElementById('wclt-product-root');
const variableRoot = document.getElementsByClassName('wclt-product-variable-root');
const variablePerStockRoot = document.getElementsByClassName('wclt-product-variable-perstock-root');
const perStockRoot = document.getElementById('wclt-product-perstock-root');





if (appRoot) {
  (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.render)((0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_containers_product__WEBPACK_IMPORTED_MODULE_1__["default"], null), appRoot);
}
if (perStockRoot) {
  (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.render)((0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_containers_product_per_stock__WEBPACK_IMPORTED_MODULE_2__["default"], null), perStockRoot);
}

/**
 * Dirty way of hooking up react into variations loaded by WC.
 * We lookup for the elements with the specified class then render
 * the component for each of the elements.
 */
jQuery(document).ready(function () {
  const wclt_rendered_variations = [];
  jQuery('#woocommerce-product-data').on('woocommerce_variations_loaded', function () {
    if (variableRoot.length > 0) {
      for (let element of variableRoot) {
        (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.render)((0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_containers_product_variable__WEBPACK_IMPORTED_MODULE_3__["default"], {
          element: element
        }), element);
      }
    }
    if (variablePerStockRoot.length > 0) {
      for (let element of variablePerStockRoot) {
        wclt_rendered_variations.push(element);
        (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.render)((0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_containers_product_variable_per_stock__WEBPACK_IMPORTED_MODULE_4__["default"], {
          element: element
        }), element);
      }
    }
  });

  // When a new variation is added, render the react component.
  jQuery('#woocommerce-product-data').on('woocommerce_variations_added', function () {
    if (variableRoot.length > 0) {
      for (let element of variableRoot) {
        (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.render)((0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_containers_product_variable__WEBPACK_IMPORTED_MODULE_3__["default"], {
          element: element
        }), element);
      }
    }
    for (let e of variablePerStockRoot) {
      if (!wclt_rendered_variations.includes(e)) {
        (0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.render)((0,_wordpress_element__WEBPACK_IMPORTED_MODULE_0__.createElement)(_containers_product_variable_per_stock__WEBPACK_IMPORTED_MODULE_4__["default"], {
          element: e
        }), e);
      }
    }
  });
});
}();
/******/ })()
;
//# sourceMappingURL=wc-lead-time-product.js.map